
 #ifndef __INTERFACE_H
 #define __INTERFACE_H

 #include "atomic.h"     // class Atomic
 #include "string.h"	 // class String
 #include "list.h"

 class Interface : public Atomic{
   public:
	       Interface( const std::string &name = "Interface" );	//Default constructor
	       virtual std::string className() const { return "Interface"; }
	       ~Interface();

   protected:
	          Model &initFunction();
	          Model &externalFunction( const ExternalMessage & );
	          Model &internalFunction( const InternalMessage & );
	          Model &outputFunction( const InternalMessage & );

   private:
	        const Port &In1,&In2,&In3;
	        Port &Out1,&Out2,&Out3;
	        Time ProcessTime;
	        int id;
	        int fromNet;
	        int temp;
         	enum State{
			            Idle,       //initial state
			            Forward,
		              };
		    State state;

 };	// class Interface

 #endif   //__INTERFACE_H
